@ECHO OFF
CLS
ECHO 
ECHO   Duke3D MAP Manager v2.0
ECHO 

REM Please read the DUKEMGR.TXT file before editing this batch file. You might
REM also want to make a backup copy.  Altered copies MAY NOT be distributed.

   IF NOT EXIST MAP\NUL MD MAP
   IF "%1"=="fix" GOTO FIXFILES
   IF "%1"=="Fix" GOTO FIXFILES
   IF "%1"=="FIX" GOTO FIXFILES
   IF "%1"=="l" GOTO LISTMAPS
   IF "%1"=="L" GOTO LISTMAPS
   IF "%1"=="list" GOTO LISTMAPS
   IF "%1"=="List" GOTO LISTMAPS
   IF "%1"=="LIST" GOTO LISTMAPS
   IF EXIST USERBAD.CON GOTO BADCONFOUND
   IF EXIST USER_MAP.TMP GOTO BADCON
   IF EXIST USER_CUS.TMP GOTO FIXUSERCON

REM  USER_MAP.USR is temp name of user's original USER.CON running a map
REM  with its own USER.CON.  Similarly for USER_MAP.DEF and USER_MAP.GAM
REM  for DEFS.CON and GAME.CON.
REM  USER_CUS.TMP is for running USER_CUS.CON.


:RUNGAME
   IF EXIST MAP\%1.MAP GOTO RUNMAP
   IF "%1"=="c" GOTO CUSTOM
   IF "%1"=="C" GOTO CUSTOM
   IF "%1"=="?" GOTO HELPCMD
   IF "%1"=="/?" GOTO HELPCMD
   IF "%1"=="-?" GOTO HELPCMD
   GOTO NORMAL


:BADCONFOUND
   ECHO Bad USER.CON file found (USERBAD.CON).  It is most likely a usermap's CON.
   ECHO Please run D.BAT in fix mode (see docs).
   GOTO BADEND

:FIXUSERCON
   IF EXIST USER_CUS.CON GOTO BADCUSCON

:FIXNOW
   RENAME USER.CON USER_CUS.CON
   RENAME USER_CUS.TMP USER.CON
   ECHO Your original USER.CON and USER_CUS.CON have been restored.
   ECHO 
   PAUSE
   ECHO 
   GOTO RUNGAME

:BADCUSCON
   ECHO Bad USER_CUS.CON file found.  Please rename or delete it so that DukeMgr
   ECHO can rename USER_CUS.TMP to USER_CUS.CON.
   GOTO BADEND

:BADCON
   IF EXIST USERBAD.CON DEL USERBAD.CON
   RENAME USER.CON USERBAD.CON
   RENAME USER_MAP.TMP USER.CON
   ECHO Bad USER.CON file found (it is most likely a usermap's stray CON).  It has
   ECHO been renamed to USERBAD.CON.  Please run the batchfile in fix mode (see docs
   ECHO or type "d ?" for info).  Your original USER.CON has been restored.
   GOTO BADEND


:NORMAL
   ECHO Running Duke Nukem 3D...
   ECHO 
   DUKE3D %1 %2 %3 %4 %5 %6 %7 %8 %9
   GOTO END


:RUNMAP

   ECHO Running %1.MAP...
   ECHO 
   ECHO If Duke Nukem crashes while running this batchfile, please read the DUKEMGR.TXT
   ECHO or type "d ?" for information on using D.BAT to restore the proper names of
   ECHO your files (in Fix mode).
   ECHO 
   PAUSE

:CHECKMAP
:CHECKCON
   IF "%2"=="c" GOTO CHECK4CUSCON
   IF "%2"=="C" GOTO CHECK4CUSCON
   IF "%2"=="u" GOTO MOVEART
   IF "%2"=="U" GOTO MOVEART
   IF EXIST MAP\%1.CON GOTO MOVECON
   IF EXIST MAP\%1.USR GOTO MOVECON
   IF EXIST MAP\%1.DEF GOTO MOVECON
   IF EXIST MAP\%1.GAM GOTO MOVECON
   GOTO MOVEART

:CHECKSTUFF
   GOTO MOVEDMO
:CHECKMID
   IF EXIST MAP\%1.MID GOTO MOVEMID
   GOTO RUNNOW

:MOVEDMO
   IF EXIST DEMO_TMP.DMO GOTO BADDMO
   IF EXIST DEMO1TMP.DMO GOTO BADDMO
   IF EXIST DEMO2TMP.DMO GOTO BADDMO
   IF EXIST DEMO3TMP.DMO GOTO BADDMO
   IF EXIST DEMO4TMP.DMO GOTO BADDMO
   IF EXIST DEMO5TMP.DMO GOTO BADDMO
   IF EXIST MAP\%1.DMO RENAME DEMO1.DMO DEMO_TMP.DMO
   IF EXIST MAP\%1.DM1 RENAME DEMO1.DMO DEMO1TMP.DMO
   IF EXIST MAP\%1.DM2 RENAME DEMO2.DMO DEMO2TMP.DMO
   IF EXIST MAP\%1.DM3 RENAME DEMO3.DMO DEMO3TMP.DMO
   IF EXIST MAP\%1.DM4 RENAME DEMO4.DMO DEMO4TMP.DMO
   IF EXIST MAP\%1.DM5 RENAME DEMO5.DMO DEMO5TMP.DMO
   IF EXIST MAP\%1.DMO MOVE MAP\%1.DMO DEMO1.DMO
   IF EXIST MAP\%1.DM1 MOVE MAP\%1.DM1 DEMO1.DMO
   IF EXIST MAP\%1.DM2 MOVE MAP\%1.DM2 DEMO2.DMO
   IF EXIST MAP\%1.DM3 MOVE MAP\%1.DM3 DEMO3.DMO
   IF EXIST MAP\%1.DM4 MOVE MAP\%1.DM4 DEMO4.DMO
   IF EXIST MAP\%1.DM5 MOVE MAP\%1.DM5 DEMO5.DMO
   GOTO CHECKMID

:MOVEMID
   IF EXIST DETHTOLL.TMP GOTO BADMID
   IF EXIST DETHTOLL.MID RENAME DETHTOLL.MID DETHTOLL.TMP
   IF EXIST MAP\%1.MID MOVE MAP\%1.MID DETHTOLL.MID
   GOTO RUNNOW


:CHECK4CUSCON
   IF NOT EXIST USER_CUS.CON GOTO CREATECON
   GOTO MOVEART


:MOVEART
   IF EXIST TILES001.ART GOTO ARTINDIR
   IF EXIST TILES002.ART GOTO ARTINDIR
   IF EXIST TILES003.ART GOTO ARTINDIR
   IF EXIST TILES004.ART GOTO ARTINDIR
   IF EXIST TILES005.ART GOTO ARTINDIR
   IF EXIST TILES006.ART GOTO ARTINDIR
   IF EXIST TILES007.ART GOTO ARTINDIR
   IF EXIST TILES008.ART GOTO ARTINDIR
   IF EXIST TILES009.ART GOTO ARTINDIR
   IF EXIST TILES010.ART GOTO ARTINDIR
   IF EXIST TILES011.ART GOTO ARTINDIR
   IF EXIST TILES012.ART GOTO ARTINDIR
   IF EXIST TILES013.ART GOTO ARTINDIR
   IF EXIST TILES014.ART GOTO ARTINDIR
   IF EXIST TILES015.ART GOTO ARTINDIR
   IF EXIST TILES016.ART GOTO ARTINDIR
   IF EXIST TILES017.ART GOTO ARTINDIR
   IF EXIST TILES018.ART GOTO ARTINDIR
   IF EXIST TILES019.ART GOTO ARTINDIR
   IF EXIST TILES020.ART GOTO ARTINDIR
   IF EXIST MAP\%1.001 MOVE MAP\%1.001 TILES001.ART
   IF EXIST MAP\%1.002 MOVE MAP\%1.002 TILES002.ART
   IF EXIST MAP\%1.003 MOVE MAP\%1.003 TILES003.ART
   IF EXIST MAP\%1.004 MOVE MAP\%1.004 TILES004.ART
   IF EXIST MAP\%1.005 MOVE MAP\%1.005 TILES005.ART
   IF EXIST MAP\%1.006 MOVE MAP\%1.006 TILES006.ART
   IF EXIST MAP\%1.007 MOVE MAP\%1.007 TILES007.ART
   IF EXIST MAP\%1.008 MOVE MAP\%1.008 TILES008.ART
   IF EXIST MAP\%1.009 MOVE MAP\%1.009 TILES009.ART
   IF EXIST MAP\%1.010 MOVE MAP\%1.010 TILES010.ART
   IF EXIST MAP\%1.011 MOVE MAP\%1.011 TILES011.ART
   IF EXIST MAP\%1.012 MOVE MAP\%1.012 TILES012.ART
   IF EXIST MAP\%1.013 MOVE MAP\%1.013 TILES013.ART
   IF EXIST MAP\%1.014 MOVE MAP\%1.014 TILES014.ART
   IF EXIST MAP\%1.015 MOVE MAP\%1.015 TILES015.ART
   IF EXIST MAP\%1.016 MOVE MAP\%1.016 TILES016.ART
   IF EXIST MAP\%1.017 MOVE MAP\%1.017 TILES017.ART
   IF EXIST MAP\%1.018 MOVE MAP\%1.018 TILES018.ART
   IF EXIST MAP\%1.019 MOVE MAP\%1.019 TILES019.ART
   IF EXIST MAP\%1.020 MOVE MAP\%1.020 TILES020.ART
   GOTO CHECKSTUFF

:MOVECON
   IF EXIST MAP\%1.USR RENAME USER.CON USER_MAP.USR
   IF EXIST MAP\%1.USR MOVE MAP\%1.USR USER.CON
REM  Next 2 lines are for USER.CONs named filename.CON instead of
REM  filename.USR (compatibility with older versions of D.BAT)
   IF EXIST MAP\%1.CON RENAME USER.CON USER_MAP.USR
   IF EXIST MAP\%1.CON MOVE MAP\%1.CON USER.CON
   IF EXIST MAP\%1.GAM RENAME GAME.CON USER_MAP.GAM
   IF EXIST MAP\%1.GAM MOVE MAP\%1.GAM GAME.CON
   IF EXIST MAP\%1.DEF RENAME DEFS.CON USER_MAP.DEF
   IF EXIST MAP\%1.DEF MOVE MAP\%1.DEF DEFS.CON
   GOTO MOVEART


:USERMAPCUS

   MOVE MAP\%1.MAP .
   RENAME USER.CON USER_CUS.TMP
   RENAME USER_CUS.CON USER.CON

   ECHO 
      DUKE3D -map %1.MAP %3 %4 %5 %6 %7 %8 %9
   ECHO 

   MOVE %1.MAP MAP
   RENAME USER.CON USER_CUS.CON
   RENAME USER_CUS.TMP USER.CON
   GOTO MOVESTUFFBACK


:RUNNOW

   IF "%2"=="c" GOTO USERMAPCUS
   IF "%2"=="C" GOTO USERMAPCUS

   MOVE MAP\%1.MAP . 
   ECHO 
     DUKE3D -map %1.MAP %2 %3 %4 %5 %6 %7 %8 %9
   ECHO 
   MOVE %1.MAP MAP

:MOVESTUFFBACK

   IF EXIST TILES001.ART MOVE TILES001.ART MAP\%1.001
   IF EXIST TILES002.ART MOVE TILES002.ART MAP\%1.002
   IF EXIST TILES003.ART MOVE TILES003.ART MAP\%1.003
   IF EXIST TILES004.ART MOVE TILES004.ART MAP\%1.004
   IF EXIST TILES005.ART MOVE TILES005.ART MAP\%1.005
   IF EXIST TILES006.ART MOVE TILES006.ART MAP\%1.006
   IF EXIST TILES007.ART MOVE TILES007.ART MAP\%1.007
   IF EXIST TILES008.ART MOVE TILES008.ART MAP\%1.008
   IF EXIST TILES009.ART MOVE TILES009.ART MAP\%1.009
   IF EXIST TILES010.ART MOVE TILES010.ART MAP\%1.010
   IF EXIST TILES011.ART MOVE TILES011.ART MAP\%1.011
   IF EXIST TILES012.ART MOVE TILES012.ART MAP\%1.012
   IF EXIST TILES013.ART MOVE TILES013.ART MAP\%1.013
   IF EXIST TILES014.ART MOVE TILES014.ART MAP\%1.014
   IF EXIST TILES015.ART MOVE TILES015.ART MAP\%1.015
   IF EXIST TILES016.ART MOVE TILES016.ART MAP\%1.016
   IF EXIST TILES017.ART MOVE TILES017.ART MAP\%1.017
   IF EXIST TILES018.ART MOVE TILES018.ART MAP\%1.018
   IF EXIST TILES019.ART MOVE TILES019.ART MAP\%1.019
   IF EXIST TILES020.ART MOVE TILES020.ART MAP\%1.020
   IF EXIST USER_MAP.USR MOVE USER.CON MAP\%1.USR
   IF EXIST USER_MAP.USR RENAME USER_MAP.USR USER.CON
   IF EXIST USER_MAP.GAM MOVE GAME.CON MAP\%1.GAM
   IF EXIST USER_MAP.GAM RENAME USER_MAP.GAM GAME.CON
   IF EXIST USER_MAP.DEF MOVE DEFS.CON MAP\%1.DEF
   IF EXIST USER_MAP.DEF RENAME USER_MAP.DEF DEFS.CON
   IF EXIST DETHTOLL.MID MOVE DETHTOLL.MID MAP\%1.MID
   IF EXIST DETHTOLL.TMP RENAME DETHTOLL.TMP DETHTOLL.MID
   IF EXIST DEMO_TMP.DMO MOVE DEMO1.DMO MAP\%1.DMO 
   IF EXIST DEMO1TMP.DMO MOVE DEMO1.DMO MAP\%1.DM1 
   IF EXIST DEMO2TMP.DMO MOVE DEMO2.DMO MAP\%1.DM2 
   IF EXIST DEMO3TMP.DMO MOVE DEMO3.DMO MAP\%1.DM3 
   IF EXIST DEMO4TMP.DMO MOVE DEMO4.DMO MAP\%1.DM4 
   IF EXIST DEMO5TMP.DMO MOVE DEMO5.DMO MAP\%1.DM5 
   IF EXIST DEMO_TMP.DMO RENAME DEMO_TMP.DMO DEMO1.DMO
   IF EXIST DEMO1TMP.DMO RENAME DEMO1TMP.DMO DEMO1.DMO
   IF EXIST DEMO2TMP.DMO RENAME DEMO2TMP.DMO DEMO2.DMO
   IF EXIST DEMO3TMP.DMO RENAME DEMO3TMP.DMO DEMO3.DMO
   IF EXIST DEMO4TMP.DMO RENAME DEMO4TMP.DMO DEMO4.DMO
   IF EXIST DEMO5TMP.DMO RENAME DEMO5TMP.DMO DEMO5.DMO

   GOTO END


:FIXFILES
   IF "%2"=="" GOTO NONAME
   IF "%2"==" " GOTO NONAME
   IF NOT EXIST %2.MAP GOTO CHECKDIR
   GOTO CONTFIXFILES
:CHECKDIR
   IF NOT EXIST MAP\%2.MAP GOTO NOFIX
:CONTFIXFILES
   IF EXIST %2.MAP MOVE %2.MAP MAP
   IF EXIST TILES001.ART MOVE TILES001.ART MAP\%2.001
   IF EXIST TILES002.ART MOVE TILES002.ART MAP\%2.002
   IF EXIST TILES003.ART MOVE TILES003.ART MAP\%2.003
   IF EXIST TILES004.ART MOVE TILES004.ART MAP\%2.004
   IF EXIST TILES005.ART MOVE TILES005.ART MAP\%2.005
   IF EXIST TILES006.ART MOVE TILES006.ART MAP\%2.006
   IF EXIST TILES007.ART MOVE TILES007.ART MAP\%2.007
   IF EXIST TILES008.ART MOVE TILES008.ART MAP\%2.008
   IF EXIST TILES009.ART MOVE TILES009.ART MAP\%2.009
   IF EXIST TILES010.ART MOVE TILES010.ART MAP\%2.010
   IF EXIST TILES011.ART MOVE TILES011.ART MAP\%2.011
   IF EXIST TILES012.ART MOVE TILES012.ART MAP\%2.012
   IF EXIST TILES013.ART MOVE TILES013.ART MAP\%2.013
   IF EXIST TILES014.ART MOVE TILES014.ART MAP\%2.014
   IF EXIST TILES015.ART MOVE TILES015.ART MAP\%2.015
   IF EXIST TILES016.ART MOVE TILES016.ART MAP\%2.016
   IF EXIST TILES017.ART MOVE TILES017.ART MAP\%2.017
   IF EXIST TILES018.ART MOVE TILES018.ART MAP\%2.018
   IF EXIST TILES019.ART MOVE TILES019.ART MAP\%2.019
   IF EXIST TILES020.ART MOVE TILES020.ART MAP\%2.020
   IF EXIST %2.CON MOVE %2.CON MAP\%2.USR
   IF EXIST %2.USR MOVE %2.USR MAP
   IF EXIST %2.GAM MOVE %2.GAM MAP
   IF EXIST %2.DEF MOVE %2.DEF MAP
   IF EXIST DEMO_TMP.DMO MOVE DEMO1.DMO MAP\%2.DMO 
   IF EXIST DEMO1TMP.DMO MOVE DEMO1.DMO MAP\%2.DM1 
   IF EXIST DEMO2TMP.DMO MOVE DEMO2.DMO MAP\%2.DM2 
   IF EXIST DEMO3TMP.DMO MOVE DEMO3.DMO MAP\%2.DM3 
   IF EXIST DEMO4TMP.DMO MOVE DEMO4.DMO MAP\%2.DM4 
   IF EXIST DEMO5TMP.DMO MOVE DEMO5.DMO MAP\%2.DM5 
   IF EXIST DEMO_TMP.DMO RENAME DEMO_TMP.DMO DEMO1.DMO
   IF EXIST DEMO1TMP.DMO RENAME DEMO1TMP.DMO DEMO1.DMO
   IF EXIST DEMO2TMP.DMO RENAME DEMO2TMP.DMO DEMO2.DMO
   IF EXIST DEMO3TMP.DMO RENAME DEMO3TMP.DMO DEMO3.DMO
   IF EXIST DEMO4TMP.DMO RENAME DEMO4TMP.DMO DEMO4.DMO
   IF EXIST DEMO5TMP.DMO RENAME DEMO5TMP.DMO DEMO5.DMO
   IF EXIST DETHTOLL.TMP MOVE DETHTOLL.MID MAP\%2.MID
   IF EXIST DETHTOLL.TMP RENAME DETHTOLL.TMP DETHTOLL.MID
   IF EXIST USERBAD.CON MOVE USERBAD.CON MAP\%2.CON
   IF EXIST USER_MAP.USR MOVE USER.CON MAP\%2.USR
   IF EXIST USER_MAP.USR RENAME USER_MAP.USR USER.CON
   IF EXIST USER_MAP.GAM MOVE GAME.CON MAP\%2.GAM
   IF EXIST USER_MAP.GAM RENAME USER_MAP.GAM GAME.CON
   IF EXIST USER_MAP.DEF MOVE DEFS.CON MAP\%2.DEF
   IF EXIST USER_MAP.DEF RENAME USER_MAP.DEF DEFS.CON

   ECHO 
   ECHO FIX finished.  If no errors were displayed then the fix was successful.
   ECHO 
   GOTO END

:NOFIX   
   ECHO Error: %2.MAP not found in this dir or MAP dir - cannot repair files.
   GOTO REALEND
:NONAME
   ECHO You must specify a MAP name to fix filenames with.  See DUKEMGR.TXT or
   ECHO type "d ?" for more info.
   GOTO REALEND

:LISTMAPS
   DIR MAP\*.MAP /w /p
   GOTO REALEND

:ARTINDIR

   ECHO Error: A stray TILES0??.ART was found in Duke directory.  Please run
   ECHO D.BAT in fix mode (see docs) if the ART is part of another usermap; rename
   ECHO or remove the ART file(s) if it is not.
   GOTO BADEND

:BADDMO

   ECHO Error: A stray DEMO?TMP.DMO was found in Duke directory.  Please run D.BAT in
   ECHO fix mode (see docs) if the DMO is part of another usermap; rename or remove
   ECHO the DMO file if it is not.
   GOTO BADEND

:BADMID

   ECHO Error: A stray DETHTOLL.TMP was found in Duke directory.  Please run D.BAT
   ECHO in fix mode (see docs) if the MID is part of another usermap; rename or
   ECHO remove the MID file if it is not.
   GOTO BADEND



:CUSTOM
   IF NOT EXIST USER_CUS.CON GOTO CREATECON
   ECHO Running Duke3D with USER_CUS.CON...
   ECHO 

   RENAME USER.CON USER_CUS.TMP
   RENAME USER_CUS.CON USER.CON

     DUKE3D %2 %3 %4 %5 %6 %7 %8 %9

   RENAME USER.CON USER_CUS.CON
   RENAME USER_CUS.TMP USER.CON
   GOTO END


:CREATECON
   COPY USER.CON USER_CUS.CON
   ECHO USER_CUS.CON file created.  Please make your changes to it.
   ECHO 
   GOTO END


:HELPCMD
   ECHO This batchfile requires DOS 6.0+ and Duke Nukem 3d v1.3d+ registered to run.
   ECHO 
   ECHO  Usage:  d {clistlfix [mapname]MAP {cu}?/?} {game parameters}
   ECHO 
   ECHO Parameters in [brackets] are mandatory, {braces} are optional.  Running with
   ECHO NO parameters starts a normal Duke Nukem game.  Game parameters are those
   ECHO parameters which DUKE3D.EXE uses, and must come AFTER the DukeMgr parameters.
   ECHO Replace MAP with appropriate map file name *without* .MAP extension.
   ECHO 
   ECHO Command line parameters for D.BAT:
   ECHO         c - Run Duke3D using USER_CUS.CON instead of USER.CON
   ECHO list or l - List all MAPs found in MAP directory
   ECHO       fix - Run under fix mode with "mapname" as source filename
   ECHO   mapfile - Run a usermap with name "mapname".MAP:
   ECHO             {c - use USER_CUS.CON} {u - use your own USER.CON}
   ECHO   ? or /? - calls this help screen
   ECHO 
   PAUSE
   CLS
   ECHO 
   ECHO Tips and Troubleshooting:
   ECHO 
   ECHO  1. Make sure you include ALL of a file's MAP, CON, MID, ART, and DMO files
   ECHO     within the MAP dir.  WAV and VOC files must remain in the DUKE3D.EXE dir.
   ECHO  2. If you're running a level with its own USER.CON file, make sure that it
   ECHO     is compatible with your version of Duke.  You will get a ton of errors if
   ECHO     you try running a ver 1.3d CON file under ver 1.5.  Use "d mapfile u" to
   ECHO     use your own USER.CON and bypass any existing CON for the map.
   ECHO  3. Fix mode is intended to repair filenames and file locations of items
   ECHO     associated with a MAP.  It can also be used to move map items into the
   ECHO     MAP directory that are in the Duke directory.  (Warning: do not use
   ECHO     the * wildcard as a mapname!)
   ECHO  4. Some specialized MAPs require special usage and movement of files and
   ECHO     may be better run using their included BATch file; however, D.BAT is
   ECHO     almost always useable if the files are named and filed correctly.
   ECHO 
   ECHO Please see DUKEMGR.TXT for detailed information.  Under any circumstance,
   ECHO running D.BAT will tell you generally what to do if there is a problem.
   ECHO 
   ECHO   Copr. (C) 1996-97 by the Chaensaw Messiah.  Do not distribute if altered.
   GOTO REALEND

:BADEND
   ECHO   Abnormal shutdown.  D.BAT will not run again until problems are fixed.
   GOTO REALEND

:END
   ECHO   Normal shutdown.

:REALEND
   ECHO 
