@ECHO OFF
CLS
ECHO 
ECHO   Duke3D Multiplayer MAP Manager v2.0 eta 1
ECHO 

REM Please read the DUKEMGR.TXT file before editing this batch file. You might
REM also want to make a backup copy.  Altered copies MAY NOT be distributed.

   IF NOT EXIST MAP\NUL MD MAP
   IF "%1"=="l" GOTO LISTMAPS
   IF "%1"=="L" GOTO LISTMAPS
   IF "%1"=="list" GOTO LISTMAPS
   IF "%1"=="List" GOTO LISTMAPS
   IF "%1"=="LIST" GOTO LISTMAPS
   IF EXIST USERBAD.CON GOTO BADCONFOUND
   IF EXIST USER_CUS.TMP GOTO FIXUSERCON
   IF EXIST USER_TMM.CON GOTO FIXUSERCON
   IF EXIST USER_MAP.TMP GOTO BADCON


:RUNGAME
   IF "%1"=="?" GOTO HELPCMD
   IF "%1"=="/?" GOTO HELPCMD
   IF "%1"=="-?" GOTO HELPCMD
   GOTO CHECKMAP


:BADCONFOUND
   ECHO Bad USER.CON file found (USERBAD.CON).  It is most likely a usermap's CON.
   ECHO Please run D.BAT in fix mode (see docs).
   GOTO BADEND

:FIXUSERCON
   IF EXIST USER_CUS.CON GOTO BADCUSCON

:FIXNOW
   RENAME USER.CON USER_CUS.CON
   IF EXIST USER_CUS.TMP RENAME USER_CUS.TMP USER.CON
   IF EXIST USER_TMM.CON RENAME USER_TMM.CON USER.CON
   ECHO Your original USER.CON and USER_CUS.CON have been restored.
   ECHO 
   PAUSE
   ECHO 
   GOTO END

:BADCUSCON
   ECHO Bad USER_CUS.CON file found.  Please rename or delete it so that DukeMgr
   ECHO can rename USER_CUS.TMP or USER_TMM.CON to USER_CUS.CON.
   GOTO BADEND

:BADCON
   IF EXIST USERBAD.CON DEL USERBAD.CON
   RENAME USER.CON USERBAD.CON
   RENAME USER_MAP.TMP USER.CON
   ECHO Bad USER.CON file found (it is most likely a usermap's stray CON).  It has
   ECHO been renamed to USERBAD.CON.  Please run the D.BAT in fix mode (see docs
   ECHO or type "d ?" for info).  Your original USER.CON has been restored.
   GOTO BADEND


:NORMALCUSCON

   RENAME USER.CON USER_TMM.CON
   RENAME USER_CUS.CON USER.CON

   ECHO Setting up play with USER_CUS.CON...
   ECHO 


:NORMAL

   ECHO Running Duke Nukem 3D Dukematch setup...
   ECHO 
   ECHO If Duke Nukem crashes while running this batchfile, please read the DUKEMGR.TXT
   ECHO or type "d ?" for information on using D.BAT to restore the proper names of
   ECHO your files (in Fix mode).
   ECHO 
   PAUSE
   SETUP %1 %2 %3 %4 %5 %6 %7 %8 %9

   IF EXIST USER_TMM.CON ECHO 
   IF EXIST USER_TMM.CON ECHO * Restoring original USER.CON...
   IF EXIST USER_TMM.CON ECHO 
   IF EXIST USER_TMM.CON RENAME USER.CON USER_CUS.CON
   IF EXIST USER_TMM.CON RENAME USER_TMM.CON USER.CON

   GOTO END



:CHECKMAP
:CHECKCON
   IF "%1"=="c" GOTO CHECK4CUSCON
   IF "%1"=="C" GOTO CHECK4CUSCON
   IF "%2"=="c" GOTO CHECK4CUSCON
   IF "%2"=="C" GOTO CHECK4CUSCON
   IF "%2"=="u" GOTO MOVEART
   IF "%2"=="U" GOTO MOVEART
   IF EXIST MAP\%1.CON GOTO MOVECON
   IF EXIST MAP\%1.USR GOTO MOVECON
   IF EXIST MAP\%1.DEF GOTO MOVECON
   IF EXIST MAP\%1.GAM GOTO MOVECON
   GOTO MOVEART

:CHECKSTUFF
   IF EXIST MAP\%1.DMO GOTO MOVEDMO
   IF EXIST MAP\%1.MID GOTO MOVEMID
   GOTO RUNNOW

:MOVEDMO
   IF EXIST DEMO1.DMO GOTO DMOINDIR
   IF EXIST MAP\%1.DMO MOVE MAP\%1.DMO DEMO1.DMO
   GOTO RUNNOW

:MOVEMID
   IF EXIST DETHTOLL.MID GOTO MIDINDIR
   IF EXIST MAP\%1.MID MOVE MAP\%1.MID DETHTOLL.MID
   GOTO RUNNOW


:CHECK4CUSCON
   IF NOT EXIST USER_CUS.CON ECHO * USER_CUS.CON created from USER.CON
   IF NOT EXIST USER_CUS.CON COPY USER.CON USER_CUS.CON
   IF "%1"=="c" GOTO NORMALCUSCON
   IF "%1"=="C" GOTO NORMALCUSCON
   GOTO MOVEART


:MOVEART
   IF EXIST TILES001.ART GOTO ARTINDIR
   IF EXIST TILES002.ART GOTO ARTINDIR
   IF EXIST TILES003.ART GOTO ARTINDIR
   IF EXIST TILES004.ART GOTO ARTINDIR
   IF EXIST TILES005.ART GOTO ARTINDIR
   IF EXIST TILES006.ART GOTO ARTINDIR
   IF EXIST TILES007.ART GOTO ARTINDIR
   IF EXIST TILES008.ART GOTO ARTINDIR
   IF EXIST TILES009.ART GOTO ARTINDIR
   IF EXIST TILES010.ART GOTO ARTINDIR
   IF EXIST TILES011.ART GOTO ARTINDIR
   IF EXIST TILES012.ART GOTO ARTINDIR
   IF EXIST TILES013.ART GOTO ARTINDIR
   IF EXIST TILES014.ART GOTO ARTINDIR
   IF EXIST TILES015.ART GOTO ARTINDIR
   IF EXIST TILES016.ART GOTO ARTINDIR
   IF EXIST TILES017.ART GOTO ARTINDIR
   IF EXIST TILES018.ART GOTO ARTINDIR
   IF EXIST TILES019.ART GOTO ARTINDIR
   IF EXIST TILES020.ART GOTO ARTINDIR
   IF EXIST MAP\%1.001 MOVE MAP\%1.001 TILES001.ART
   IF EXIST MAP\%1.002 MOVE MAP\%1.002 TILES002.ART
   IF EXIST MAP\%1.003 MOVE MAP\%1.003 TILES003.ART
   IF EXIST MAP\%1.004 MOVE MAP\%1.004 TILES004.ART
   IF EXIST MAP\%1.005 MOVE MAP\%1.005 TILES005.ART
   IF EXIST MAP\%1.006 MOVE MAP\%1.006 TILES006.ART
   IF EXIST MAP\%1.007 MOVE MAP\%1.007 TILES007.ART
   IF EXIST MAP\%1.008 MOVE MAP\%1.008 TILES008.ART
   IF EXIST MAP\%1.009 MOVE MAP\%1.009 TILES009.ART
   IF EXIST MAP\%1.010 MOVE MAP\%1.010 TILES010.ART
   IF EXIST MAP\%1.011 MOVE MAP\%1.011 TILES011.ART
   IF EXIST MAP\%1.012 MOVE MAP\%1.012 TILES012.ART
   IF EXIST MAP\%1.013 MOVE MAP\%1.013 TILES013.ART
   IF EXIST MAP\%1.014 MOVE MAP\%1.014 TILES014.ART
   IF EXIST MAP\%1.015 MOVE MAP\%1.015 TILES015.ART
   IF EXIST MAP\%1.016 MOVE MAP\%1.016 TILES016.ART
   IF EXIST MAP\%1.017 MOVE MAP\%1.017 TILES017.ART
   IF EXIST MAP\%1.018 MOVE MAP\%1.018 TILES018.ART
   IF EXIST MAP\%1.019 MOVE MAP\%1.019 TILES019.ART
   IF EXIST MAP\%1.020 MOVE MAP\%1.020 TILES020.ART
   GOTO CHECKSTUFF

:MOVECON
   IF EXIST MAP\%1.USR RENAME USER.CON USER_MAP.USR
   IF EXIST MAP\%1.USR MOVE MAP\%1.USR USER.CON
REM  Next 2 lines are for USER.CONs named filename.CON instead of
REM  filename.USR (compatibility with older versions of D.BAT)
   IF EXIST MAP\%1.CON RENAME USER.CON USER_MAP.USR
   IF EXIST MAP\%1.CON MOVE MAP\%1.CON USER.CON
   IF EXIST MAP\%1.GAM RENAME GAME.CON USER_MAP.GAM
   IF EXIST MAP\%1.GAM MOVE MAP\%1.GAM GAME.CON
   IF EXIST MAP\%1.DEF RENAME DEFS.CON USER_MAP.DEF
   IF EXIST MAP\%1.DEF MOVE MAP\%1.DEF DEFS.CON
   GOTO MOVEART


:USERMAPCUSCON

   MOVE MAP\%1.MAP .
   IF NOT EXIST USER_CUS.CON ECHO * USER_CUS.CON created from USER.CON
   IF NOT EXIST USER_CUS.CON ECHO 
   IF NOT EXIST USER_CUS.CON COPY USER.CON USER_CUS.CON
   ECHO Setting up play with USER_CUS.CON...
   ECHO 
   ECHO If Duke Nukem crashes while running this batchfile, please read the DUKEMGR.TXT
   ECHO or type "d ?" for information on using D.BAT to restore the proper names of
   ECHO your files (in Fix mode).
   ECHO 
   PAUSE

   RENAME USER.CON USER_CUS.TMP
   RENAME USER_CUS.CON USER.CON

   ECHO 
      SETUP %3 %4 %5 %6 %7 %8 %9
   ECHO 

   MOVE %1.MAP MAP
   IF EXIST USER_CUS.TMP ECHO 
   IF EXIST USER_CUS.TMP ECHO * Restoring original USER.CON...
   IF EXIST USER_CUS.TMP ECHO 
   RENAME USER.CON USER_CUS.CON
   RENAME USER_CUS.TMP USER.CON
   GOTO MOVESTUFFBACK


:RUNNOW

   IF "%2"=="c" GOTO USERMAPCUSCON
   IF "%2"=="C" GOTO USERMAPCUSCON

   ECHO Running %1.MAP Dukematch setup...
   ECHO 
   ECHO If Duke Nukem crashes while running this batchfile, please read the DUKEMGR.TXT
   ECHO or type "d ?" for information on using D.BAT to restore the proper names of
   ECHO your files (in Fix mode).
   ECHO 
   PAUSE

   IF EXIST MAP\%1.MAP MOVE MAP\%1.MAP . 
   ECHO 
     SETUP %2 %3 %4 %5 %6 %7 %8 %9
   ECHO 
   IF EXIST %1.MAP MOVE %1.MAP MAP\%1.MAP

:MOVESTUFFBACK

   IF EXIST TILES001.ART MOVE TILES001.ART MAP\%1.001
   IF EXIST TILES002.ART MOVE TILES002.ART MAP\%1.002
   IF EXIST TILES003.ART MOVE TILES003.ART MAP\%1.003
   IF EXIST TILES004.ART MOVE TILES004.ART MAP\%1.004
   IF EXIST TILES005.ART MOVE TILES005.ART MAP\%1.005
   IF EXIST TILES006.ART MOVE TILES006.ART MAP\%1.006
   IF EXIST TILES007.ART MOVE TILES007.ART MAP\%1.007
   IF EXIST TILES008.ART MOVE TILES008.ART MAP\%1.008
   IF EXIST TILES009.ART MOVE TILES009.ART MAP\%1.009
   IF EXIST TILES010.ART MOVE TILES010.ART MAP\%1.010
   IF EXIST TILES011.ART MOVE TILES011.ART MAP\%1.011
   IF EXIST TILES012.ART MOVE TILES012.ART MAP\%1.012
   IF EXIST TILES013.ART MOVE TILES013.ART MAP\%1.013
   IF EXIST TILES014.ART MOVE TILES014.ART MAP\%1.014
   IF EXIST TILES015.ART MOVE TILES015.ART MAP\%1.015
   IF EXIST TILES016.ART MOVE TILES016.ART MAP\%1.016
   IF EXIST TILES017.ART MOVE TILES017.ART MAP\%1.017
   IF EXIST TILES018.ART MOVE TILES018.ART MAP\%1.018
   IF EXIST TILES019.ART MOVE TILES019.ART MAP\%1.019
   IF EXIST TILES020.ART MOVE TILES020.ART MAP\%1.020
   IF EXIST USER_MAP.USR MOVE USER.CON MAP\%1.USR
   IF EXIST USER_MAP.USR RENAME USER_MAP.USR USER.CON
   IF EXIST USER_MAP.GAM MOVE GAME.CON MAP\%1.GAM
   IF EXIST USER_MAP.GAM RENAME USER_MAP.GAM GAME.CON
   IF EXIST USER_MAP.DEF MOVE DEFS.CON MAP\%1.DEF
   IF EXIST USER_MAP.DEF RENAME USER_MAP.DEF DEFS.CON
   IF EXIST DETHTOLL.MID MOVE DETHTOLL.MID MAP\%1.MID
   IF EXIST DEMO1.DMO MOVE DEMO1.DMO MAP\%1.DMO

   GOTO END


:FIXFILES
   ECHO You must use D.BAT for Fix mode.
   GOTO REALEND

:LISTMAPS
   DIR MAP\*.MAP /w /p
   GOTO REALEND

:ARTINDIR

   ECHO Error: A stray TILES0??.ART was found in Duke directory.  Please run
   ECHO D.BAT in fix mode (see docs) if the ART is part of another usermap; rename
   ECHO or remove the ART file(s) if it is not.
   GOTO BADEND

:DMOINDIR

   ECHO Error: A stray DEMO1.DMO was found in Duke directory.  Please run D.BAT in
   ECHO fix mode (see docs) if the DMO is part of another usermap; rename or remove
   ECHO the DMO file if it is not.
   GOTO BADEND

:MIDINDIR

   ECHO Error: A stray DETHTOLL.MID was found in Duke directory.  Please run D.BAT in
   ECHO fix mode (see docs) if the MID is part of another usermap; rename or remove
   ECHO the MID file if it is not.
   GOTO BADEND



:HELPCMD
   ECHO This batchfile requires DOS 6.0+ and Duke Nukem 3d v1.3d+ registered to run.
   ECHO 
   ECHO  Usage:  dm {listlMAP {cu}?} {game parameters}
   ECHO 
   ECHO Parameters in [brackets] are mandatory, {braces} are optional.  Running with
   ECHO NO parameters starts a normal Duke Nukem game.  Game parameters are those
   ECHO parameters which DUKE3D.EXE uses, and must come AFTER the DukeMgr parameters.
   ECHO Replace MAP with appropriate map file name *without* .MAP extension.
   ECHO 
   ECHO Command line parameters for D.BAT:
   ECHO   list; l - List all MAPs found in MAP directory
   ECHO       MAP - Run a usermap with name mapfile.MAP:
   ECHO             c - use USER_CUS.CON for USER.CON;
   ECHO             u - use only your own USER/DEFS/GAME CON files
   ECHO         ? - calls this help screen
   ECHO 
   PAUSE
   CLS
   ECHO 
   ECHO Tips and Troubleshooting:
   ECHO 
   ECHO    1. Make sure you include ALL of a file's MAP, CON, MID and ART files within
   ECHO       the MAP directory.  WAV and VOC files must remain in the DUKE3D.EXE dir.
   ECHO    2. If you're running a level with its own USER.CON file, make sure that it
   ECHO       is compatible with your version of Duke.  You will get a ton of errors if
   ECHO       you try running a ver 1.3d CON file under ver 1.5.  Use "d mapfile u" to
   ECHO       use your own USER.CON and bypass any existing CON for the map.
   ECHO    3. All players MUST have IDENTICAL USER/GAME/DEFS CON files for any
   ECHO       circumstances listed above, or Dukematch will NOT WORK right!
   ECHO 
   ECHO Please see DUKEMGR.TXT for detailed information.  Under any circumstance,
   ECHO running DM.BAT will tell you generally what to do if there is a problem.
   ECHO 
   ECHO   Copr. (C) 1996-97 by the Chaensaw Messiah.  Do not distribute if altered.
   GOTO REALEND

:BADEND
   ECHO   Abnormal shutdown.  D.BAT will not run again until problems are fixed.
   GOTO REALEND

:END
   ECHO   Normal shutdown.

:REALEND
   ECHO 
